<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Google\Client as GoogleClient;

use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Http;
use Laravel\Sanctum\PersonalAccessToken;
use Illuminate\Support\Facades\DB;
use App\Utility\MimoUtility;
use Config;


use Session;
class FcmController extends Controller
{
    public function index()
  {
    /********* Generating the Client and OAuthToken ******************/

    $redirect_uri = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];

    $client = new GoogleClient();
    $client->setScopes('Slides::PRESENTATIONS');
    $client->setAuthConfig('app/slide-api-credential.json');
    $client->setRedirectUri($redirect_uri);
    $client->setAccessType('offline');
    $client->setPrompt('select_account consent');

    // Load previously authorized token from a file, if it exists.
    // The file token.json stores the user's access and refresh tokens, and is
    // created automatically when the authorization flow completes for the first
    // time.
    $tokenPath = 'token.json';
    if (file_exists($tokenPath)) {
      $accessToken = json_decode(file_get_contents($tokenPath), true);
      $client->setAccessToken($accessToken);
    }

    // If there is no previous token or it's expired.
    if ($client->isAccessTokenExpired()) {
      // Refresh the token if possible, else fetch a new one.
      if ($client->getRefreshToken()) {
        $client->fetchAccessTokenWithRefreshToken($client->getRefreshToken());
      } else {
        // Request authorization from the user.
        $authUrl = $client->createAuthUrl();
        header('Location:' . $authUrl);
        if (isset($_GET['code'])) {
          $accessToken = $client->fetchAccessTokenWithAuthCode($_GET['code'], $_SESSION['code_verifier']);
          $client->setAccessToken($accessToken);
          // redirect back to the example
          header('Location: ' . filter_var($redirect_uri, FILTER_SANITIZE_URL));
          $client->setAccessToken($accessToken);
        }
      }
      // Save the token to a file.
      if (!file_exists(dirname($tokenPath))) {
        mkdir(dirname($tokenPath), 0700, true);
      }
      file_put_contents($tokenPath, json_encode($client->getAccessToken()));
    }

    /******** End of Authorization Flow *********/

    $slides = new Slides($client);

    $presentation = new Presentation([
      'title' => 'My First Slide'
    ]);
}
    
    public function sendPushNotification()
    {  


        
          $credentialsFilePath = Storage::path('app/json/client_secret_600193137354-llholl7q42c88sqcu3ejn6frbajhistk.apps.googleusercontent.com.json');
    
        $firebase = (new Factory)->withServiceAccount($credentialsFilePath);
 
        $messaging = $firebase->createMessaging();
 
        $message = CloudMessage::fromArray([
            'notification' => [
                'title' => 'Hello from Firebase!',
                'body' => 'This is a test notification.'
            ],
            'topic' => 'global'
        ]);
 
        $messaging->send($message);
 
        return response()->json(['message' => 'Push notification sent successfully']);
    }
    public function updateDeviceToken(Request $request)
    {
        $request->validate([
            'user_id' => 'required|exists:users,id',
            'fcm_token' => 'required|string',
        ]);
        
        $request->user()->update(['fcm_token' => $request->fcm_token]);

        return response()->json(['message' => 'Device token updated successfully']);
    }
//  string $token_user
  static  public function sendFcmNotification(string $token_user, string $id_user)
    {
    
    //  echo response()->json(DB::table('akar_type')->first());
        $user = \App\Models\User::find(1);
    
        $fcm = 'eKq7YvcUTy-Nvty8IexJ9A:APA91bGfUARliuxTtgw2PXBg9jtzba3GRRVohL3z2Dn_s7xKMfaAjeTWfYKQdKRVssOkixIw4IrQ_GatsDXql8Ti2ouZ4c4JFq6AZAAxGb4xWtWrjWgWu4ZL1hN357pBUhgitoNmBUTE';

        if (!$fcm) {
            return response()->json(['message' => 'User does not have a device token'], 400);
        }
  
        
        $credentialsFilePath = Storage::path('app/json/akare-b4cf8-firebase-adminsdk-cw95h-88b9458c48.json');
        putenv('GOOGLE_APPLICATION_CREDENTIALS='.$credentialsFilePath);
        $client =  new GoogleClient();
        $client->addScope('https://www.googleapis.com/auth/firebase.messaging');
        //$client->setAuthConfig($credentialsFilePath);
        
        $client->useApplicationDefaultCredentials();
        //$client->setSubject($sender);
        $client->setApplicationName("Quickstart");
        
        
        $client->refreshTokenWithAssertion();
        $token = $client->getAccessToken();

        $access_token = $token['access_token'];
    
        $headers = [
            "Authorization: Bearer " . $access_token, "Content-Type: application/vnd.ni-payment.v2+json", "Accept: application/vnd.ni-payment.v2+json",
            'Content-Type: application/json'
        ];
if($token_user=="addnew"){
        
  $title = "طلب اضافة أعلان";
  
  $user =DB::table('users')->where('user_type',"sport")->where('state' , 'open')->where('device_token' ,'!=', '')->where('device_token' ,'!=', null)->where('id' ,'!=',$id_user) ->get();
  foreach ($user as $key => $row) 
      {
        $description = "يوجد طلب اضافة أعلان جديد";
        $data = [
            "message" => [
                "token" => $row->device_token,
                "notification" => [
                    "title" => $title,
                    "body" => $description,
                ],
              
            ]
        ];
        $payload = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/akare-b4cf8/messages:send");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        curl_setopt($ch, CURLOPT_VERBOSE, true); // Enable verbose output for debugging
        $response = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);

      }
    }
      
        if ($err) {
            return response()->json([
                'message' => 'Curl Error: ' . $err
            ], 500);
        } else {
            return response()->json([
                'message' => 'Notification has been sent',
                'response' => json_decode($response, true)
            ]);
        }
    }
}
