<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Services\SmsService;
use Twilio\Rest\Client;
class SmsController extends Controller
{
    protected $smsService;

    public function __construct(SmsService $smsService)
    {
        $this->smsService = $smsService;
    }

    public function sendCode(Request $request)
    {
        $sid = env("TWILIO_SID"); // Your Account SID from www.twilio.com/console
            $token = env("TWILIO_AUTH_TOKEN"); // Your Auth Token from www.twilio.com/console
            $type = "1"; // sms type
            $phoneNumber = $request->input('phone');
            $client = new Client($sid, $token);
            try {
                 $client->messages->create(
                    $type == 1? $phoneNumber : "whatsapp:".$phoneNumber, // Text this number
                    array(
                        'from' =>  $type == 1? env('TWILIO_PHONE') : "whatsapp:".env('TWILIO_PHONE'), // From a valid Twilio number
                        'body' => "hhhhhhhhhhhhhhhhhh"
                    )
                );
            } catch (\Exception $e) {
            }
            
    
    }
    public function verifyCode(Request $request)
{

    
    $request->validate([
        'phone' => 'required',
        'code' => 'required',
    ]);

    $phoneNumber = $request->input('phone');
    $code = $request->input('code');

    $cachedCode = \Cache::get('verification_code_' . $phoneNumber);

    if ($cachedCode && $cachedCode == $code) {
        return response()->json(['message' => 'Verification successful']);
    }

    return response()->json(['message' => 'Invalid code'], 400);
}
}
